#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <list>
#include "SDL.h"
#include "SDL_image.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_mixer.h"
#include "main.h"
#include "vesiefu.h"
using namespace std;
#define FULLSCREEN 1

char pelikulussa=1;
int lopetus=0;
SDL_Surface *screen,*vesiScreen;
unsigned int aika,alkuaika;
list<SDLKey> keyEvents;
Uint8 *keyState;
typedef list<WORM_OSA *> WORM;
WORM *worm;
int wormX,wormY;
int wormXI,wormYI;
char matoa[TAULU_LEV][TAULU_KOR];
int pisteet=0;
int kuvat=0;
unsigned int peli_aika=0;
SDL_Surface *logot[3];

int eventFilter(const SDL_Event *event)
{
SDLKey keysym;

switch (event->type)
{
case SDL_KEYDOWN:
keyState=SDL_GetKeyState(NULL);

if(keyState[SDLK_ESCAPE]==SDL_PRESSED) {
pelikulussa=0;lopetus=1;
return 0;
}
keysym=event->key.keysym.sym;
switch (keysym)
{
case SDLK_LEFT:
case SDLK_RIGHT:
case SDLK_UP:
case SDLK_DOWN:
keyEvents.push_back(keysym);
break;
case SDLK_KP4:
keyEvents.push_back(SDLK_LEFT);
break;
case SDLK_KP6:
keyEvents.push_back(SDLK_RIGHT);
break;
case SDLK_KP8:
keyEvents.push_back(SDLK_UP);
break;
case SDLK_KP2:
keyEvents.push_back(SDLK_DOWN);
break;
case SDLK_SPACE:
kuvat++;
break;
}
break;

case SDL_KEYUP:
keyState=SDL_GetKeyState(NULL);
break;
}
return 1;
}

SDL_Surface* setVideoMode(int lev,int kor,char fullscreen)
{
int fullscreenMask=fullscreen?SDL_FULLSCREEN:0;
return 
SDL_SetVideoMode(lev,kor,32,SDL_HWSURFACE|SDL_DOUBLEBUF|fullscreenMask);
}

char peli(unsigned int tick)
{
const int FPS=PELI_FPS;
static int round=0;

if(peli_aika==0) peli_aika=tick;
if(tick<peli_aika) return 0;

while(peli_aika<tick)
{
round++;
peli_aika += 1000 / FPS;
pisteet++;
if(keyEvents.size()>0)
{
SDLKey key=*keyEvents.begin();
keyEvents.pop_front();
wormXI=wormYI=0;
switch (key)
{
case SDLK_LEFT:
wormXI=-1;
break;
case SDLK_RIGHT:
wormXI=1;
break;
case SDLK_UP:
wormYI=-1;
break;
case SDLK_DOWN:
wormYI=1;
break;
}
}
wormX += wormXI;
wormY += wormYI;
if(wormY<0)
{
wormY=0;
pelikulussa=0;
}
if(wormY >= TAULU_KOR)
{
wormY=TAULU_KOR-1;
pelikulussa=0;
}
if(wormX<0)
wormX=TAULU_LEV-1;
if(wormX >= TAULU_LEV)
wormX=0;
if(pelikulussa)
{
WORM_OSA *wu=new WORM_OSA;
wu->x=wormX;
wu->y=wormY;
worm->push_front(wu);
if(0<matoa[wormX][wormY])
pelikulussa=0;
matoa[wormX][wormY]=1;
}

vesiefu_setkor(0x1ff,wormX*TAULU_OSA_LEV,wormY*TAULU_OSA_KOR,TAULU_OSA_LEV,TAULU_OSA_KOR); 

if(round&1)
{
WORM::iterator i=worm->end();
--i;
int wx=(*i)->x,wy=(*i)->y;

vesiefu_setkor(0xff,wx*TAULU_OSA_LEV,wy*TAULU_OSA_KOR,TAULU_OSA_LEV,TAULU_OSA_KOR);
delete *i;
worm->pop_back();
matoa[wx][wy]=0;
}
}
return 1;
}

void drawWorm(SDL_Surface *ruutu)
{
WORM::iterator i,wormEnd;
int x,y,kohta=0;
if(SDL_LockSurface(ruutu)<0) return;
wormEnd=worm->end();
for (i=worm->begin();i!=wormEnd;i++)
{
int wx=(*i)->x,wy=(*i)->y;
kohta++;
for (y=wy*TAULU_OSA_KOR;y<(wy+1)*TAULU_OSA_KOR;y++)
{
for (x=wx*TAULU_OSA_LEV;x<(wx+1)*TAULU_OSA_LEV;x++)
{
int r=250-(kohta%10)*10;
int g=250-((kohta+4)%9)*11;
int b=250-((kohta+7)%8)*12;
int vari=(r<<16)|(g<<8)|b;
if(kohta==1) vari=0xfffffff;
((unsigned int *)ruutu->pixels)[y*ruutu->pitch / 
ruutu->format->BytesPerPixel+x]=vari;
}
}
}
SDL_UnlockSurface(ruutu);
}

void drawMuuta(SDL_Surface *ruutu)
{
char puskuri[100];
if(SDL_LockSurface(ruutu)<0) return;
/* valko reunat yls && alas */
memset(ruutu->pixels,0xff,LEV*4);
memset((unsigned int *)ruutu->pixels+(KOR-1)*ruutu->pitch / 
ruutu->format->BytesPerPixel,0xff,LEV*4);
SDL_UnlockSurface(ruutu);
/* pistein piirto */
sprintf(puskuri,"%d",pisteet);
stringRGBA(screen,5,5,puskuri,0,0,0,100);
stringRGBA(screen,10,10,puskuri,200,200,200,100);
}

char vesi(unsigned int tick,char muutos)
{
muutos |= vesiefu(vesiScreen,tick);
if(muutos)
{
if(SDL_LockSurface(screen)<0) return 0;
if(SDL_LockSurface(vesiScreen)<0) return 0;
int i;
for (i=0;i<screen->h;i++)
memcpy((char *)screen->pixels+i*screen->pitch,(char 
*)vesiScreen->pixels+i*vesiScreen->pitch,LEV*4);
SDL_UnlockSurface(vesiScreen);
SDL_UnlockSurface(screen);
}
return muutos;
}

int main(int argc,char *argv[])
{
int i,j;
char fullscreen=FULLSCREEN;
Mix_Music *music;
if(SDL_Init(SDL_INIT_AUDIO|SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_NOPARACHUTE)<0) {
fprintf(stderr,"CAN NOT init SDL: %s\n",SDL_GetError());
exit(1);
}
atexit(SDL_Quit);
if(Mix_OpenAudio(22050,AUDIO_S16,2,4096)<0)
{
fprintf(stderr,"CAN NOT init SDL AUDIO: %s\n",SDL_GetError());
exit(1);
}
music=Mix_LoadMUS("vesiworm.xm");
if(music==NULL)
{
fprintf(stderr,"CAN NOT LOAD MUSIC\n");
exit(1);
}
screen=setVideoMode(LEV,KOR,fullscreen);
if(screen==NULL) {
fprintf(stderr,"CAN NOT set %dx%d mode: %s\n",LEV,KOR,SDL_GetError());
exit(1);
}
worm=new WORM;
vesiScreen=SDL_CreateRGBSurface(SDL_SWSURFACE,LEV,KOR,32,0x00ff0000,0x0000ff00,0x000000ff,0xff000000);
SDL_SetEventFilter(eventFilter);
alkuaika=SDL_GetTicks();
srand(time(NULL));
logot[0]=IMG_Load("happosoft.jpg");
logot[1]=IMG_Load("logo-kuva.jpg");
logot[2]=IMG_Load("gameover.jpg");
Mix_FadeInMusic(music,-1,2000);
while(!SDL_QuitRequested() && !lopetus)
{
///// ALKU KUVAT
pelikulussa=1;kuvat=0;
pisteet=0;
for (i=0;i<TAULU_LEV;i++) for (j=0;j<TAULU_KOR;j++) matoa[i][j]=0;
worm->clear();
wormX=LEV / TAULU_OSA_LEV / 2;
wormY=KOR / TAULU_OSA_KOR / 2;
wormXI=wormYI=0;
//if(rand()%2)
wormXI=(rand()%2)*2-1;
//else
//wormYI=(rand()%2)*2-1;
vesiefu_alku();
aika=0;alkuaika=SDL_GetTicks();
while(!lopetus && pelikulussa && !SDL_QuitRequested() && kuvat<2)
{
unsigned int time=SDL_GetTicks()-alkuaika;
SDL_BlitSurface(logot[kuvat],0,screen,0);
SDL_Flip(screen);
if(time>3000 && kuvat<1) kuvat=1;
if(time>8000 && kuvat<2) kuvat=2;
}

//// PELI !!!
aika=0;alkuaika=SDL_GetTicks();
peli_aika=0;
while(!lopetus && pelikulussa && !SDL_QuitRequested())
{
char muutos=0;
unsigned int time=SDL_GetTicks()-alkuaika;
aika=SEKOITUS(aika,time,4);
muutos |= peli(aika);
muutos |= vesi(aika,muutos);
if(muutos) {
drawWorm(screen);
drawMuuta(screen);
SDL_Flip(screen);
} else SDL_Delay(1);
}
// LOPPU
aika=0;alkuaika=SDL_GetTicks();
pelikulussa=1;kuvat=0;
while(!lopetus && pelikulussa && !SDL_QuitRequested() && kuvat<1)
{
char puskuri[100];
unsigned int time=SDL_GetTicks()-alkuaika;
if(time>5000) pelikulussa=0;
SDL_BlitSurface(logot[2],0,screen,0);
/* loppu tekstit */
stringRGBA(screen,100,120,"pisteet",200,200,200,200);
/* pistein piirto */
sprintf(puskuri,"%d",pisteet);
stringRGBA(screen,125,145,puskuri,0,0,0,100);
stringRGBA(screen,120,140,puskuri,200,200,200,200);
stringRGBA(screen,50,200,"happosoft: osmo&vili 
happonen",200,200,200,100);
stringRGBA(screen,50,210,"kiitos:whitecrow",200,200,200,100);
SDL_Flip(screen);
}
vesiefu_loppu();
}
Mix_FreeMusic(music);
return 0;
}
